package com.webonlineapp.hyjavaapexdemo.util;

import com.vaadin.flow.component.UI;

public class Audio {
	private boolean audioLoaded = false;
	
	
	/**
	 * 
	 */
	public void play(SoundEffect sound, Number volume, boolean loop) {
		if (audioLoaded) {
			resume();
		}
		else {
			String js = "chartAudio = document.createElement('audio'); chartAudio.setAttribute('src', '" + 
					ServletUtil.getContextPath() + 
					"/sound/" + sound.toString() + "'); chartAudio.setAttribute('type', \"audio/mpeg\"); chartAudio.volume = " + 
					volume + "; chartAudio.loop=" + loop + "; chartAudio.play();";
			
			UI.getCurrent().getPage().executeJs(js);
			audioLoaded = true;
		}
	}
	
	/**
	 * 
	 */
	public void pause() {
		if (audioLoaded) {
			UI.getCurrent().getPage().executeJs("chartAudio.pause();");
		}
	}
	
	/**
	 * 
	 */
	public void resume() {
		if (audioLoaded) {
			UI.getCurrent().getPage().executeJs("chartAudio.play();");
		}
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isAudioLoaded() {
		return audioLoaded;
	}




	/**
	 * 
	 * 
	 *
	 */
	public enum SoundEffect{
		PIANO("Passacaglia – Handel-Halvorsen.mp3");
		
	    private final String enumValue;
	
	    /**
	     * 
	     * @param enumValue
	     */
	    private SoundEffect(String enumValue) {
	        this.enumValue = enumValue;
	    }
	
	    /**
	     * 
	     */
	    @Override
	    public String toString() {
	        return this.enumValue;
	    }
	}

}
