package com.webonlineapp.hyjavaapexdemo.util;

import java.io.File;
import java.net.URL;

import com.vaadin.flow.server.VaadinRequest;
import com.vaadin.flow.server.VaadinServlet;
import com.vaadin.flow.server.VaadinServletRequest;

import jakarta.servlet.ServletContext;
import jakarta.servlet.http.HttpServletRequest;

/**
 *  
 */
public class ServletUtil {
	private static String HOST_NAME = "";
	private static String LOCATION = "";
	
	
	/**
	 * 
	 */
	public static void setHostDetails() {
		HttpServletRequest httpServletRequest = ((VaadinServletRequest) VaadinRequest.getCurrent()).getHttpServletRequest();
		HOST_NAME = httpServletRequest.getServerName();
		LOCATION = httpServletRequest.getRequestURL().toString();
	}

	/**
	 * Usage: URL url = GeneralUtil.getServletContext().getResource("/docroot/reports/abc.xml");
	 * @return
	 */
    static public ServletContext getServletContext() {
        return VaadinServlet.getCurrent().getServletContext();
    }
 
    /**
     * Usage: Resource res = new FileResource(new File(GeneralUtil.getBasePath() + "/docroot/abc.pdf"));
     * @return
     */
//    static public String getBasePath() {
//        return VaadinService.getCurrent().getBaseDirectory().getPath();
//    }
    
    /**
     * 
     * @return
     */
    static public String getHost() {
    	return HOST_NAME;
     }
    
    /**
     * 
     * @return
     */
//    static public int getPort() {
//        return UI.getCurrent().getPage().getLocation().getPort();
//    }
    
    
    // NEW FOR FLOW
    
    /**
     * 
     * @return
     */
    public static String getLocation() {
    	return LOCATION;
    }
    
    
    /**
	 * 
	 * @param servlet
	 * @return
	 */
    public static File getBaseDirectory(VaadinServlet servlet) {
        final String realPath = getResourcePath(servlet.getServletContext(), "/");
        
        if (realPath == null) {
            return null;
        }
        
        return new File(realPath);
    }
    
    /**
     * 
     * @return
     */
    public static String getContextPath() {
    	return VaadinServlet.getCurrent().getServletContext().getContextPath();
    }
    
    /**
     * 
     * @param servletContext
     * @param path
     * @return
     */
    private static String getResourcePath(ServletContext servletContext, String path) {
		String resultPath = null;
		
		resultPath = servletContext.getRealPath(path);

		if (resultPath != null) {
			return resultPath;
		} 
		else {
			try {
				final URL url = servletContext.getResource(path);
				resultPath = url.getFile();
			}
			catch (final Exception e) {

			}
		}

		return resultPath;
    }
    
}
