package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class Candlestick extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);
		
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("AAPL Stock Price");
		
		seriesCandlestick.getDataGrouping().getUnits().add(new Unit("week", Arrays.asList(1)));
		seriesCandlestick.getDataGrouping().getUnits().add(new Unit("month", Arrays.asList(1, 2, 3, 4, 6)));
		
		seriesCandlestick.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-ohlc.json"));
		chartOptions.getSeries().add(seriesCandlestick);
		
		return highStock;
	}
	
}