package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.Compare;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class CompareMultipleSeries extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getRangeSelector().setSelected(4);

		YAxis yAxi = new YAxis();
		yAxi.getLabels().setFormat("{#if (gt value 0)}+{/if}{value}%");
		yAxi.getPlotLinesSingle().setValue(0).setWidth(2).setColor(new Color("silver"));
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getPlotOptions().getSeries().setCompare(Compare.PERCENT).setShowInNavigator(true);
		 
		chartOptions.getTooltip()
			.setPointFormat("<span style='color:{series.color}'>{series.name}</span>: <b>{point.y}</b> ({point.change}%)<br/>")
			.setValueDecimals(2).setSplit(true);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("MSFT");
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-msft-c.json"));
		chartOptions.getSeries().add(seriesLine);
		
		seriesLine = new SeriesLine();
		seriesLine.setName("AAPL");
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-aapl-c.json"));
		chartOptions.getSeries().add(seriesLine);
		
		seriesLine = new SeriesLine();
		seriesLine.setName("GOOG");
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-goog-c.json"));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}