package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.HorizontalAlign;
import com.hyjavastock.model.highstock.constants.PointIntervalUnit;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class CumulativeSum extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("Cumulative Sum").setAlign(HorizontalAlign.LEFT);
		chartOptions.getSubtitle().setText("Displays the sum of all the previous values and the current value (only within visible range)")
			.setAlign(HorizontalAlign.LEFT);;

		chartOptions.getPlotOptions().getSeries()
			.setCumulative(true)
			.setPointStart("2023-01-01")
			.setPointIntervalUnit(PointIntervalUnit.DAY);
		
		chartOptions.getRangeSelector().setEnabled(false);
		
		chartOptions.getTooltip()
			.setPointFormat("<span style=\"color:{series.color}\">{series.name}</span>: <b>{point.y}</b> ({point.cumulativeSum})<br/>")
			.setChangeDecimals(2)
			.setValueDecimals(2)
			.setValuePrefix("$")
			.setValueSuffix("USD");

		chartOptions.getXAxisSingle().setMinRange(3 * 24 * 36e5).setMax("2023-01-06");

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("The Local Bakery").setDataAsArrayNumber(new ArrayList<Number>(Arrays.asList(
				678.78, 545.33, 788.72, 406.2, 744.87, 466.03, 822.7, 337.52, 396.67, 470.89)));
		chartOptions.getSeries().add(seriesLine);
		
		seriesLine = new SeriesLine();
		seriesLine.setName("The Local Fishmarket").setDataAsArrayNumber(new ArrayList<Number>(Arrays.asList(
				1340.72, 982.43, 1437.99, 1476.2, 670.23, 429.58, 897.52, 845.11, 1275.79, 1843.01)));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}