package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.FlagsShape;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesFlags;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.hyjavastock.model.highstock.series.seriesflags.Data;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class FlagsPlacement extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("USD to EUR exchange rate");
		chartOptions.getRangeSelector().setSelected(1);

		YAxis yAxi = new YAxis();
		yAxi.setTop("15%").setHeight("85%").getTitle().setText("Exchange rate");
		chartOptions.getYAxis().add(yAxi);
		
		yAxi = new YAxis();
		yAxi.setHeight("15%");
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getPlotOptions().getFlags().getAccessibility().setExposeAsGroupOnly(true).setDescription("Flagged events.");
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("USD to EUR").setId("dataseries");
		seriesLine.getTooltip().setValueDecimals(4);
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-usdeur.json"));
		chartOptions.getSeries().add(seriesLine);
		
		SeriesFlags seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
			.setName("Flags on series")
			.setOnSeries("dataseries")
			.setShape(FlagsShape.SQUAREPIN);
		seriesFlags.getDataAsArrayObject().add(new Data().setX(1640908800000L - 60 * 24 * 36e5).setTitle("On series"));
		seriesFlags.getDataAsArrayObject().add(new Data().setX(1640908800000L - 30 * 24 * 36e5).setTitle("On series"));
		chartOptions.getSeries().add(seriesFlags);
		
		seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
			.setName("Flags on axis")
			.setShape(FlagsShape.SQUAREPIN);
		seriesFlags.getDataAsArrayObject().add(new Data().setX(1640908800000L - 45 * 24 * 36e5).setTitle("On axis"));
		seriesFlags.getDataAsArrayObject().add(new Data().setX(1640908800000L - 15 * 24 * 36e5).setTitle("On axis"));
		chartOptions.getSeries().add(seriesFlags);
		
		seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
			.setName("Flags in pane")
			.setYAxis(1)
			.setShape(FlagsShape.SQUAREPIN);
		seriesFlags.getDataAsArrayObject().add(new Data().setX(1640908800000L - 40 * 24 * 36e5).setTitle("In pane"));
		seriesFlags.getDataAsArrayObject().add(new Data().setX(1640908800000L - 15 * 24 * 36e5).setTitle("In pane"));
		chartOptions.getSeries().add(seriesFlags);
		
		return highStock;
	}
	
}