package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.FlagsShape;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesFlags;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.hyjavastock.model.highstock.series.seriesflags.Data;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class FlagsShapesAndColors extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("USD to EUR exchange rate");
		chartOptions.getRangeSelector().setSelected(4);

		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Exchange rate");
		chartOptions.getYAxis().add(yAxi);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("USD to EUR").setId("dataseries");
		seriesLine.getTooltip().setValueDecimals(4);
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-usdeur.json"));
		chartOptions.getSeries().add(seriesLine);
		
		SeriesFlags seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
			.setOnSeries("dataseries")
			.setShape(FlagsShape.SQUAREPIN)
			.setWidth(16);
		seriesFlags.getDataAsArrayObject()
			.add(new Data().setX("2021-02-22").setTitle("A").setText("Shape: \"squarepin\""));
		seriesFlags.getDataAsArrayObject()
			.add(new Data().setX("2021-04-28").setTitle("A").setText("Shape: \"squarepin\""));
		chartOptions.getSeries().add(seriesFlags);
		
		seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
			.setShape(FlagsShape.CIRCLEPIN)
			.setWidth(16);
		seriesFlags.getDataAsArrayObject()
			.add(new Data().setX("2021-03-01").setTitle("B").setText("Shape: \"circlepin\""));
		seriesFlags.getDataAsArrayObject()
			.add(new Data().setX("2021-04-01").setTitle("B").setText("Shape: \"circlepin\""));
		chartOptions.getSeries().add(seriesFlags);
		
		seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
			.setOnSeries("dataseries")
			.setWidth(16);
		seriesFlags.setColor(chartOptions.getColors().get(0)).setFillColor(chartOptions.getColors().get(0));
		seriesFlags.getStyle().setColor(new Color("white"));
		seriesFlags.getStates().getHover().setFillColor(new Color("#395C84"));
		seriesFlags.getDataAsArrayObject()
			.add(new Data().setX("2021-03-10").setTitle("C").setText("Shape: \"flag\""));
		seriesFlags.getDataAsArrayObject()
			.add(new Data().setX("2021-04-11").setTitle("C").setText("Shape: \"flag\""));
		chartOptions.getSeries().add(seriesFlags);
		
		return highStock;
	}
	
}