package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesHollowcandlestick;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class HollowCandlestick extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		chartOptions.getRangeSelector().setSelected(1);
		chartOptions.getTitle().setText("AAPL Stock Price");
		
		chartOptions.getNavigator().getSeriesAsObject().setColor(chartOptions.getColors().get(0));
		
		SeriesHollowcandlestick seriesHollowcandlestick = new SeriesHollowcandlestick();
		seriesHollowcandlestick.setType(SeriesType.HOLLOWCANDLESTICK).setName("Hollow Candlestick");
		seriesHollowcandlestick.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-ohlcv.json"));
		chartOptions.getSeries().add(seriesHollowcandlestick);
		
		return highStock;
	}
	
}