package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesOhlc;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class OHLC extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(2);
		
		SeriesOhlc seriesOhlc = new SeriesOhlc();
		seriesOhlc.setType(SeriesType.OHLC).setName("AAPL Stock Price");
		
		seriesOhlc.getDataGrouping().getUnits().add(new Unit("week", Arrays.asList(1)));
		seriesOhlc.getDataGrouping().getUnits().add(new Unit("month", Arrays.asList(1, 2, 3, 4, 6)));
		
		seriesOhlc.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-ohlc.json"));
		chartOptions.getSeries().add(seriesOhlc);
		
		return highStock;
	}
	
}