package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class PlotBandsOnYAxis extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);

		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Stock price");
		yAxi.getPlotBandsSingle()
			.setFrom(222.01).setTo(259.02)
			.setColor(new Color().setRGBA(68, 170, 213, 0.2))
			.getLabel().setText("Last quarter year\\'s value range");
		
		chartOptions.getYAxis().add(yAxi);

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("AAPL Stock Price").getTooltip().setValueDecimals(2);
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-c.json"));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}