package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class PointMarkersOnly extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(2);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("AAPL Stock Price").setLineWidth(0);
		seriesLine.getMarker().setEnabled(true).setRadius(2);
		seriesLine.getTooltip().setValueDecimals(2);
		seriesLine.getStates().getHover().setLineWidthPlus(0);
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-c.json"));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}