package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.HorizontalAlign;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.ZoomType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class PointsWithDataGrouping extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		chartOptions.getChart().getZooming().setType(ZoomType.X);

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.DAY).setCount(3).setText("3d"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.WEEK).setCount(1).setText("1w"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(1).setText("1m"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(6).setText("6m"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.YEAR).setCount(1).setText("1y"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setText("ALL"));
		chartOptions.getRangeSelector().setSelected(3);
		
		chartOptions.getTitle().setText("Hourly temperatures in Vik i Sogn, Norway, 2009-2017").setAlign(HorizontalAlign.LEFT);
		
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Temperature (°C)");
		chartOptions.getYAxis().add(yAxi);
				
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("Temperature")
			.getTooltip().setValueDecimals(1).setValueSuffix("°C");
		seriesLine.setPointStart(1230764400000L);
		seriesLine.setPointInterval(3600000);
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-large-dataset.json"));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}

}