package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.ChartType;
import com.hyjavastock.model.highstock.series.SeriesArearange;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class AreaRange extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		
		chartOptions.getChart().setType(ChartType.AREARANGE);
	    
		chartOptions.getTitle().setText("Temperature variation by day");
		chartOptions.getRangeSelector().setSelected(2);
		chartOptions.getTooltip().setValueSuffix("°C");
		
		SeriesArearange seriesArearange = new SeriesArearange();
		seriesArearange.setName("Temperatures");
		seriesArearange.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-temp-range.json"));
		chartOptions.getSeries().add(seriesArearange);
		
		return highStock;
	}
	
}