package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.common.Stop;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.ChartType;
import com.hyjavastock.model.highstock.series.SeriesArearange;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class ColumnRange extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		
		chartOptions.getChart().setType(ChartType.COLUMNRANGE);
	    
		chartOptions.getTitle().setText("Temperature variation by day");
		chartOptions.getRangeSelector().setSelected(2);
		chartOptions.getTooltip().setValueSuffix("°C");

		chartOptions.getColorAxisSingle().setStops(Arrays.asList(new Stop(0, new Color("#1E90FF")),
																 new Stop(0.5, new Color("#FFFF99")),
																 new Stop(1, new Color("#FF3333"))));
		
		SeriesArearange seriesArearange = new SeriesArearange();
		seriesArearange.setName("Temperatures");
		seriesArearange.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-temp-range.json"));
		chartOptions.getSeries().add(seriesArearange);
		
		return highStock;
	}
	
}