package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.FlagsShape;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesFlags;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.hyjavastock.model.highstock.series.seriesflags.Data;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class FlagsMarkingEvents extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("Bitcoin Historical Price and Halvings");
		
		chartOptions.getXAxisSingle().setOverscroll(2678400000L);	// 1 month
		
		chartOptions.getRangeSelector().setSelected(3)
			.setButtons(Arrays.asList(
				new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(3).setText("3m").setTitle("View 3 months"),
				new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(6).setText("6m").setTitle("View 6 months"),
				new Buttons().setType(RangeSelectorButtonType.YTD).setText("YTD").setTitle("View year to date"),
				new Buttons().setType(RangeSelectorButtonType.YEAR).setCount(1).setText("1y").setTitle("View 1 year"),
				new Buttons().setType(RangeSelectorButtonType.ALL).setText("ALL").setTitle("View all")
					));

		chartOptions.getAccessibility().setTypeDescription("Stock chart with a line series and a flags series indicating key events.");

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("Bitcoin Price").setColor(new Color("#ffbf00")).setId("dataseries")
					.getTooltip().setValueDecimals(2).setValuePrefix("$");
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-btc-historical.json"));
		chartOptions.getSeries().add(seriesLine);

		
		SeriesFlags seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
					.setColor(new Color("#fb922c"))
					.setOnSeries("dataseries")
					.setShape(FlagsShape.SQUAREPIN)
					.setShowInNavigator(true);
		
		SeriesFlags navigatorOptions = new SeriesFlags(); 
		navigatorOptions.setType(SeriesType.FLAGS).setOnSeries("undefined").setDataAsArrayObject(Arrays.asList(
				new Data().setX("2016-07-09").setTitle("2nd"),
				new Data().setX("2020-05-11").setTitle("3rd")				
				));
		seriesFlags.setNavigatorOptions(navigatorOptions);
		
		seriesFlags.getAccessibility().setExposeAsGroupOnly(true).setDescription("Bitcoin Halving Events");

		seriesFlags.setDataAsArrayObject(Arrays.asList(
				new Data().setX("2016-07-09").setTitle("2nd Halving").setText("Reward down: 25 BTC to 12.5 BTC per block"),
				new Data().setX("2020-05-11").setTitle("3rd Halving").setText("Reward down: 12.5 BTC to 6.25 BTC per block")
				));	
		chartOptions.getSeries().add(seriesFlags);

		
		seriesFlags = new SeriesFlags();
		seriesFlags.setType(SeriesType.FLAGS)
					.setColor(new Color("#fb922c"))
					.setShape(FlagsShape.SQUAREPIN)
					.setShowInNavigator(true);
		
		navigatorOptions = new SeriesFlags(); 
		navigatorOptions.setType(SeriesType.FLAGS).setDataAsArrayObject(Arrays.asList(
				new Data().setX("2024-04-19").setTitle("4th")
				));		
		seriesFlags.setNavigatorOptions(navigatorOptions);
		
		seriesFlags.getAccessibility().setExposeAsGroupOnly(true).setDescription("Bitcoin Halving Events");

		seriesFlags.setDataAsArrayObject(Arrays.asList(
				new Data().setX("2024-04-19").setTitle("4th Halving").setText("Reward down: 6.25 BTC to 3.125 BTC per block")
				));	
		chartOptions.getSeries().add(seriesFlags);
		
		return highStock;
	}
	
}