package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.HorizontalAlign;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.hyjavastock.model.highstock.series.SeriesHeikinashi;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class HeikenAshi extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("Candlestick and Heiken Ashi series comparison.").setAlign(HorizontalAlign.LEFT);
		chartOptions.getRangeSelector().setSelected(1);
		
		YAxis yAxis = new YAxis();
		yAxis.setHeight("50%").getTitle().setText("Candlestick");
		chartOptions.getYAxis().add(yAxis);
		
		yAxis = new YAxis();
		yAxis.setTop("50%").setHeight("50%").setOffset(0).getTitle().setText("Heikin Ashi");
		chartOptions.getYAxis().add(yAxis);
		
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("Candlestick");
		seriesCandlestick.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-ohlcv.json"));
		chartOptions.getSeries().add(seriesCandlestick);
		
		SeriesHeikinashi seriesHeikinashi = new SeriesHeikinashi();
		seriesHeikinashi.setType(SeriesType.HEIKINASHI).setName("Heikin Ashi").setYAxis(1);
		seriesHeikinashi.getTooltip().setValueDecimals(2);
		seriesHeikinashi.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-ohlcv.json"));
		chartOptions.getSeries().add(seriesHeikinashi);
		
		return highStock;
	}
	
}