package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class IntraDayCandleStick extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL stock price by minute");

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.HOUR).setCount(1).setText("1h"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.DAY).setCount(1).setText("1D"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setCount(1).setText("ALL"));
		chartOptions.getRangeSelector().setSelected(1).setInputEnabled(false);
		
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("AAPL");
		seriesCandlestick.getTooltip().setValueDecimals(2);
	
		seriesCandlestick.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-new-intraday.json"));
		chartOptions.getSeries().add(seriesCandlestick);
		
		return highStock;
	}
	
}