package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.ArrayList;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.common.LinearGradient;
import com.hyjavastock.model.common.NullOption;
import com.hyjavastock.model.common.Stop;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesArea;
import com.hyjavastock.model.highstock.xaxis.Breaks;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class IntraDayWithBreaks extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL stock price by minute");
		chartOptions.getSubtitle().setText("Using explicit breaks for nights and weekends");
		
		chartOptions.getXAxisSingle().getBreaks().add(new Breaks()
				.setFrom("2011-10-06 16:00").setTo("2011-10-07 08:00").setRepeat(24 * 36e5));
		chartOptions.getXAxisSingle().getBreaks().add(new Breaks()
				.setFrom("2011-10-07 16:00").setTo("2011-10-10 08:00").setRepeat(7 * 24 * 36e5));

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.HOUR).setCount(1).setText("1h"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.DAY).setCount(1).setText("1D"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setCount(1).setText("ALL"));
		chartOptions.getRangeSelector().setSelected(1).setInputEnabled(false);
		
		SeriesArea seriesArea = new SeriesArea();
		seriesArea.setType(SeriesType.AREA).setName("AAPL").setGapSize(5).setThreshold(NullOption.NULL_NUMBER);
		seriesArea.getTooltip().setValueDecimals(2);
		
		ArrayList<Stop> stops = new ArrayList<Stop>();
		stops.add(new Stop(0, chartOptions.getColors().get(0)));
		stops.add(new Stop(1, new Color().setColorValue("Highcharts.color(Highcharts.getOptions().colors[0]).setOpacity(0).get('rgba')")));
		seriesArea.setFillColor(new Color(new LinearGradient(0, 0, 0, 1), stops));
		
		seriesArea.getDataAsJsValue().setJsValue(DemoChartData.getResource("samples-data-new-intraday.json"));
		chartOptions.getSeries().add(seriesArea);
		
		return highStock;
	}
	
}