package com.webonlineapp.hyjavastockdemo12.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.DashStyle;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.hyjavastock.model.highstock.yaxis.PlotLines;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class PlotLinesOnYAxis extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);
		
		chartOptions.getTooltip().setValueDecimals(4).setShared(true);

		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Stock price");
		
		PlotLines pl = new PlotLines();
		pl.setValue(222.01)
			.setColor(new Color("green"))
			.setDashStyle(DashStyle.SHORTDASH)
			.setWidth(2)
			.getLabel().setText("Last quarter minimum").setY(15);
		yAxi.getPlotLines().add(pl);
		
		pl = new PlotLines();
		pl.setValue(259.02)
			.setColor(new Color("red"))
			.setDashStyle(DashStyle.SHORTDASH)
			.setWidth(2)
			.getLabel().setText("Last quarter maximum");
		yAxi.getPlotLines().add(pl);
		
		chartOptions.getYAxis().add(yAxi);

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("AAPL Stock Price").getTooltip().setValueDecimals(2);
		seriesLine.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-c.json"));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}