package com.webonlineapp.hyjavastockdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.rangeselector.buttons.DataGrouping;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class RangeSelectorWithGrouping extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		
		highStock.getGlobalOptions().getLang().setRangeSelectorZoom("Granularity");
		
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getSubtitle().setText("Custom data grouping tied to range selector");

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(3).setText("Day")
				.setDataGrouping(new DataGrouping().setForced(true).setUnits(Arrays.asList(new Unit("day", Arrays.asList(1))))));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.YEAR).setCount(1).setText("Week")
				.setDataGrouping(new DataGrouping().setForced(true).setUnits(Arrays.asList(new Unit("week", Arrays.asList(1))))));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setText("Month")
				.setDataGrouping(new DataGrouping().setForced(true).setUnits(Arrays.asList(new Unit("month", Arrays.asList(1))))));
		chartOptions.getRangeSelector().setSelected(2).setAllButtonsEnabled(true).getButtonTheme().setWidth(60);
		
		SeriesLine series = new SeriesLine();
		series.setType(SeriesType.LINE).setName("AAPL");
		series.getMarker().setEnabled(true).setRadius(3).setLineWidth(1).setLineColor(new Color("#FFFFFF"));
		series.getTooltip().setValueDecimals(2);
		series.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-c.json"));
		chartOptions.getSeries().add(series);
		
		return highStock;
	}

}