package com.webonlineapp.hyjavastockdemo12.examplecharts;
import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.HorizontalAlign;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.hyjavastock.model.highstock.series.SeriesColumn;
import com.webonlineapp.hyjavastockdemo12.chartdata.DemoChartData;
import com.webonlineapp.hyjavastockdemo12.charts.DemoChartBase;

public class TwoPanesCandlestick extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		
		chartOptions.getTitle().setText("AAPL Historical");
		chartOptions.getRangeSelector().setSelected(4);
		
		YAxis yAxi = new YAxis();
		yAxi.getLabels().setAlign(HorizontalAlign.RIGHT).setX(-3);
		yAxi.getTitle().setText("OHLC");
		yAxi.setHeight("60%").setLineWidth(2).getResize().setEnabled(true);
		chartOptions.getYAxis().add(yAxi);
		
		yAxi = new YAxis();
		yAxi.getLabels().setAlign(HorizontalAlign.RIGHT).setX(-3);
		yAxi.getTitle().setText("Volume");
		yAxi.setTop("65%").setHeight("35%").setOffset(0).setLineWidth(2);
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getTooltip().setSplit(true);
				
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("AAPL");
		seriesCandlestick.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-ohlc.json"));
		seriesCandlestick.getDataGrouping().getUnits().add(new Unit("week", Arrays.asList(1)));
		seriesCandlestick.getDataGrouping().getUnits().add(new Unit("month", Arrays.asList(1,2,3,4,6)));
		chartOptions.getSeries().add(seriesCandlestick);

		SeriesColumn seriesColumn = new SeriesColumn();
		seriesColumn.setType(SeriesType.COLUMN).setName("Volume").setYAxis(1);
		seriesColumn.getDataAsJsValue().setJsValue(DemoChartData.getResource("demo-live-data-aapl-v.json"));
		seriesColumn.getDataGrouping().getUnits().add(new Unit("week", Arrays.asList(1)));
		seriesColumn.getDataGrouping().getUnits().add(new Unit("month", Arrays.asList(1,2,3,4,6)));

		chartOptions.getSeries().add(seriesColumn);
		
		return highStock;
	}
	
}